Name: gd2
Version: 2.0.4
Release: alt2

Summary: A graphics library for drawing image files in various formats
License: BSD-style
Group: Graphics
Url: http://www.boutell.com/gd

%define srcname gd-%version
Source: %url/http/%srcname.tar.bz2
Patch1: http://downloads.rhyme.com.au/gd/patch_gd2.0.4_gif_20021023.bz2
Patch2: gd-2.0.4-alt-configure.patch
Patch3: gd-2.0.4-alt-makefile.patch

Prefix: %prefix

# Automatically added by buildreq on Sun Nov 03 2002
BuildRequires: XFree86-devel freetype2-devel libjpeg-devel libpng-devel xpm-devel zlib-devel

%def_with gif

%package -n lib%name
Summary: A graphics library for drawing image files in various formats
Group: System/Libraries

%package -n lib%name-devel
Summary: The development libraries and header files for lib%name
Group: Development/C
Requires: lib%name = %version-%release
Conflicts: libgd-devel < 2.0.4

%package -n lib%name-devel-static
Summary: The development static library for lib%name
Group: Development/C
Requires: lib%name-devel = %version-%release
Conflicts: libgd-devel-static < 2.0.4

%package utils
Summary: The utilities for drawing image files in various formats
Group: Graphics
Requires: lib%name = %version-%release
Conflicts: gd-utils < 2.0.4

%description
Gd is a graphics library.  It allows your code to quickly draw images
complete with lines, arcs, text, multiple colors, cut and paste from
other images, and flood fills, and write out the result as a PNG or
JPEG file.  This is particularly useful in World Wide Web applications,
where PNG and JPEG are two of the formats accepted for inline images
by most browsers.

Gd is not a paint program.  If you are looking for a paint program, you
are looking in the wrong place.  If you are not a programmer, you are
looking in the wrong place, unless you are installing a required
library in order to run an application.

Gd does not provide for every possible desirable graphics operation.
It is not necessary or desirable for Gd to become a kitchen-sink
graphics package, but version 2.0 does include most frequently
requested features, including both truecolor and palette images,
resampling (smooth resizing of truecolor images) and so forth.

%description -n lib%name
Gd is a graphics library for drawing image files in various formats.  Gd
allows your code to quickly draw images (lines, arcs, text, multiple colors,
cutting and pasting from other images, flood fills) and write out the result
as a jpeg, png or wbmp file.  Gd is particularly useful in web applications,
where jpeg, png or wbmp files are commonly used as inline images.  Note,
however, that Gd is not a paint program.

Install this package if you are using Gd-based applications.

%description -n lib%name-devel
Gd is a graphics library for drawing image files in various formats.  Gd
allows your code to quickly draw images (lines, arcs, text, multiple colors,
cutting and pasting from other images, flood fills) and write out the result
as a jpeg, png or wbmp file.  Gd is particularly useful in web applications,
where jpeg, png or wbmp files are commonly used as inline images.  Note,
however, that Gd is not a paint program.

Install this package if you are developing applications which need to draw
image files in various formats.

%description -n lib%name-devel-static
Gd is a graphics library for drawing image files in various formats.  Gd
allows your code to quickly draw images (lines, arcs, text, multiple colors,
cutting and pasting from other images, flood fills) and write out the result
as a jpeg, png or wbmp file.  Gd is particularly useful in web applications,
where jpeg, png or wbmp files are commonly used as inline images.  Note,
however, that Gd is not a paint program.

Install this package if you are developing statically linked
applications which need to draw image files in various formats.

%description utils
Gd is a graphics library.  It allows your code to quickly draw images
complete with lines, arcs, text, multiple colors, cut and paste from
other images, and flood fills, and write out the result as a PNG or
JPEG file.  This is particularly useful in World Wide Web applications,
where PNG and JPEG are two of the formats accepted for inline images
by most browsers.

Gd is not a paint program.  If you are looking for a paint program, you
are looking in the wrong place.  If you are not a programmer, you are
looking in the wrong place, unless you are installing a required
library in order to run an application.

Gd does not provide for every possible desirable graphics operation.
It is not necessary or desirable for Gd to become a kitchen-sink
graphics package, but version %version does include most frequently
requested features, including both truecolor and palette images,
resampling (smooth resizing of truecolor images) and so forth.

%prep
%setup -q -n %srcname
%{?_with_gif:%patch1 -p1}
%patch2 -p1
./configure
%patch3 -p1

%build
cat >libgd.map <<__EOF__
gif {
  global:
$(sed -ne 's,^[[:alpha:]][^[:space:]]*[[:space:]]\+\(gd[^(]*\)(.*,    \1;,pg' gd.h |fgrep -i gif)
};
__EOF__

# First build shared library,
%make_build libgd.a RPM_OPT_FLAGS="$RPM_OPT_FLAGS %optflags_shared"
m=`echo %version |cut -d. -f1`
gcc -shared -Wl,-soname,libgd.so.$m -o libgd.so.%version \
	-Wl,-whole-archive libgd.a -Wl,-no-whole-archive \
	%{?_with_gif:-Wl,--version-script=libgd.map} \
	-lpng -ljpeg -lfreetype -L/usr/X11R6/lib -lXpm -lX11 \
	#
%__ln_s -f libgd.so.%version libgd.so.$m
%__ln_s -f libgd.so.%version libgd.so
rm -rf shared
mkdir shared
mv libgd.so* shared/

# then static library and utils.
make clean
cp -a shared/* .
%make_build libgd.a utils

%{?!_without_test:%make_build test}

%install
%__mkdir_p $RPM_BUILD_ROOT{%_libdir,%_bindir,%_includedir}
%make_install install
%__cp -a libgd.a $RPM_BUILD_ROOT%_libdir/
%__cp -a shared/* $RPM_BUILD_ROOT%_libdir/
%define _customdocdir %_docdir/%srcname

%post -n lib%name -p %post_ldconfig
%postun -n lib%name -p %postun_ldconfig

%files -n lib%name
%_libdir/*.so.*

%files -n lib%name-devel
%_libdir/*.so
%_includedir/*
%doc index.html

%files -n lib%name-devel-static
%_libdir/*.a

%files utils
%_bindir/*

%changelog
* Mon Nov 04 2002 Dmitry V. Levin <ldv@altlinux.org> 2.0.4-alt2
- Fixed shared library linkage.

* Sat Nov 02 2002 Dmitry V. Levin <ldv@altlinux.org> 2.0.4-alt1
- 2.0.4 (named as libgd2).

* Sat Nov 02 2002 Dmitry V. Levin <ldv@altlinux.org> 1.8.4-alt5
- Removed all mdk patches;
  redone build of shared library and utilities.
- Enforce compile and link without freetype 1.x (rh).
- Relocated Gd utilities to right place (%_bindir).
- Renamed to gd1.
- Added URL.
- Added GIF support from http://www.rhyme.com.au/gd/.
- Added versioning for GIF API.

* Thu Mar 21 2002 AEN <aen@logic.ru> 1.8.4-alt4
- symlinks fixed (#734)

* Thu Feb 06 2002 AEN <aen@logic.ru> 1.8.4-alt3
- really built with ttf support

* Wed Oct 10 2001 Dmitry V. Levin <ldv@altlinux.ru> 1.8.4-alt2
- Rebuilt with libpng.so.3.

* Tue Jul 17 2001 Dmitry V. Levin <ldv@altlinux.ru> 1.8.4-alt1
- 1.8.4
- Built with freetype2.
- Moved static library to devel-static subpackage.

* Fri Jan 19 2001 Dmitry V. Levin <ldv@fandra.org> 1.8.3-ipl1mdk
- Initial revision (merged specfiles from RH and MDK).
